#version 150

#moj_import <fog.glsl>
#moj_import <ocean.glsl>

uniform sampler2D Sampler0;

uniform vec4 ColorModulator;
uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;

in float vertexDistance;
in vec4 vertexColor;
in vec2 texCoord0;

in vec3 physics_localPosition;
in float physics_localWaviness;

out vec4 fragColor;

void main() {
    vec3 normal = physics_waveNormal(physics_localPosition.xz, physics_localWaviness, physics_gameTime);

	// VANILLA STYLE
	vec4 oceanColor = vec4(vec3(mix(normal.x * 0.5 + 0.5, 1.0, pow(normal.y, 4.0))), 1.0);
	vec4 oceanHighlights = vec4(vec3(mix(-normal.x * 0.5 + 0.5, 0.0, pow(normal.y, 4.0))), 0.0);
    vec4 color = texture(Sampler0, texCoord0) * oceanColor * ColorModulator * vertexColor + pow(oceanHighlights, vec4(1.3)) * 0.9;
    
    // IMS STYLE
    //vec4 color = texture(Sampler0, texCoord0) * vec4(normal * 0.5 + 0.5, 1.0).rrra * ColorModulator * vertexColor;
    //color.b = max(color.b * 5, 30);
    //color.a = 0.3;
    
    // DEBUGGING STYLE
    //color = vec4(normal * 0.5 + 0.5, 1.0) * ColorModulator * vertexColor;
    
    fragColor = linear_fog(color, vertexDistance, FogStart, FogEnd, FogColor);
}
